CREATE TABLE `events` (
  `event_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` text,
  `recurrence_id` int(10),
  `exdates` text,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `start` int(11) DEFAULT '0',
  `end` int(11) DEFAULT '0',
  `expires` int(11) DEFAULT '0',
  `rr` varchar(1) default NULL,
  `recurring` text NOT NULL,
  `occurrences` int(11) DEFAULT '0',
  `byday` text,
  `bymonth` text, 
  `bymonthday` text,
  `summary` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `location` varchar(255) NOT NULL DEFAULT '',
  `categories` varchar(255) NOT NULL DEFAULT '',
  `group` text,
  `caldav` text,
  `url` text,
  `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `del` int(1) NOT NULL DEFAULT '0',
  `reminder` int(10) DEFAULT NULL,
  `reminderservice` text,
  `remindermailto` text,
  `remindersent` int(10) DEFAULT NULL,
  `notified` int(1) NOT NULL default '0',
  `client` text,
 PRIMARY KEY (`event_id`),
 CONSTRAINT `user_id_fk_events` FOREIGN KEY (`user_id`)
   REFERENCES `users`(`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
)  ENGINE=INNODB   CHARACTER SET utf8 COLLATE utf8_general_ci; 

CREATE TABLE `events_cache` (
  `event_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` text,
  `recurrence_id` int(10),
  `exdates` text,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `start` int(11) DEFAULT '0',
  `end` int(11) DEFAULT '0',
  `expires` int(11) DEFAULT '0',
  `rr` varchar(1) default NULL,
  `recurring` text NOT NULL,
  `occurrences` int(11) DEFAULT '0',
  `byday` text,
  `bymonth` text, 
  `bymonthday` text,
  `summary` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `location` varchar(255) NOT NULL DEFAULT '',
  `categories` varchar(255) NOT NULL DEFAULT '',
  `group` text,
  `caldav` text,
  `url` text,
  `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `del` int(1) NOT NULL DEFAULT '0',
  `reminder` int(10) DEFAULT NULL,
  `reminderservice` text,
  `remindermailto` text,
  `remindersent` int(10) DEFAULT NULL,
  `notified` int(1) NOT NULL default '0',
  `client` text,
 PRIMARY KEY (`event_id`),
 CONSTRAINT `user_id_fk_events_cache` FOREIGN KEY (`user_id`)
   REFERENCES `users`(`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
)  ENGINE=INNODB   CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `events_caldav` (
  `event_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` text,
  `recurrence_id` int(10),
  `exdates` text,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `start` int(11) DEFAULT '0',
  `end` int(11) DEFAULT '0',
  `expires` int(11) DEFAULT '0',
  `rr` varchar(1) default NULL,
  `recurring` text NOT NULL,
  `occurrences` int(11) DEFAULT '0',
  `byday` text,
  `bymonth` text, 
  `bymonthday` text,
  `summary` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `location` varchar(255) NOT NULL DEFAULT '',
  `categories` varchar(255) NOT NULL DEFAULT '',
  `group` text,
  `caldav` text,
  `url` text,
  `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `del` int(1) NOT NULL DEFAULT '0',
  `reminder` int(10) DEFAULT NULL,
  `reminderservice` text,
  `remindermailto` text,
  `remindersent` int(10) DEFAULT NULL,
  `notified` int(1) NOT NULL default '0',
  `client` text,
 PRIMARY KEY (`event_id`),
 CONSTRAINT `user_id_fk_events_caldav` FOREIGN KEY (`user_id`)
   REFERENCES `users`(`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
)  ENGINE=INNODB   CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `reminders` (
  `reminder_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `events` int(10) unsigned DEFAULT NULL,
  `cache` int(10) unsigned DEFAULT NULL,
  `caldav` int(10) unsigned DEFAULT NULL,
  `type` text,
  `props` text,
  `runtime` int(11) NOT NULL,
 PRIMARY KEY (`reminder_id`),
 CONSTRAINT `reminders_ibfk_1` FOREIGN KEY (`user_id`)
   REFERENCES `users` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
)  ENGINE=InnoDB   CHARACTER SET utf8 COLLATE utf8_general_ci;