<?php

/**
 * contactus
 *
 * @version 2.6.4 - 10.09.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 *
 **/
 
/**
 * Usage: http://mail4us.net/myroundcube/
 *
 * REQUIREMENTS: plugin taskbar
 *
 *               If you don't use it nav in: ./?_action=plugin.contactus
 *
 **/
 
class contactus extends rcube_plugin
{

  public $task = 'login|logout|settings';
  public $noajax = true;
  public $noframe = true;

  /* unified plugin properties */
  static private $plugin = 'contactus';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = null;
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '2.6.4';
  static private $date = '10-09-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.7.1',
    'PHP' => '5.2.1',
    'recommended_plugins' => array('taskbar' => 'config'),
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';

  function init()
  {
    $this->add_texts('localization/');
    $this->register_action('plugin.contactus', array($this, 'contactus_dummy'));
    $rcmail = rcmail::get_instance();
    if(!in_array('global_config', $rcmail->config->get('plugins'))){
      $this->load_config();
    }
    $this->add_hook('startup', array($this, 'contactus_form'));
    $this->add_hook('startup', array($this, 'contactus_send'));
    $this->add_hook('render_page', array($this, 'render_page'));
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }

  function contactus_dummy(){
    return;
  }
  
  function render_page($p){
    if($p['template'] == 'contactus.contactus'){
      $rcmail = rcmail::get_instance();
      $skin  = $rcmail->config->get('skin');
      if(!file_exists("plugins/contactus/skins/$skin/contactus.css"))
        $skin = "default";
      $this->include_stylesheet('skins/' . $skin . '/contactus.css');
    }
    return $p;
  }

  function contactus_form($args)
  {
    $rcmail = rcmail::get_instance();
    if($rcmail->action == "plugin.contactus"){
      $rcmail->output->set_env('task','dummy');
      $this->include_script("contactus.js");
      $rcmail->output->add_label(
        'contactus.noemailwarning',
        'contactus.nosubjectwarning',
        'contactus.nomessagewarning'
      ); 
      $rcmail->output->set_pagetitle($this->gettext('contactus'));
      $rcmail->output->set_env('keep_alive', false);
      if(!$_SESSION['captcha_solved'])
        $rcmail->config->set('captcha_auth', true);
      $rcmail->output->send("contactus.contactus");
    }
    return $args;
  }
  
  function contactus_send($args)
  {
    $rcmail = rcmail::get_instance();
    if($rcmail->action == "plugin.contactus_send"){
    
      $isHTML = $rcmail->config->get('contactus_html_body') ;
      
      $to = $rcmail->config->get('contactus_recipient') ;
      $from = get_input_value('_email', RCUBE_INPUT_POST);
      if(check_email($from)){
        $subject = $rcmail->config->get('contactus_subject_prefix') . " " . get_input_value('_subject', RCUBE_INPUT_POST);
        $subject = '=?UTF-8?B?'.base64_encode($subject).'?=';
        $body  = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN">' . "\r\n";
        $body .= "<html><body>\r\n";
        $body .= nl2br(get_input_value('_message', RCUBE_INPUT_POST));
        $body .= "<br />___________________________________<br />";
        $body .= "Client-IP: " . $this->getVisitorIP() . "<br />";
        $body .= "Server-IP: " . $_SERVER['SERVER_ADDR'] . "<br />";
        $body .= "</body></html>\r\n";
      
        $ctb = md5(rand() . microtime());

        $headers  = "Return-Path: $from\r\n";
        $headers .= "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: multipart/alternative; boundary=\"=_$ctb\"\r\n";
        $headers .= "X-Domain: " . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "\r\n";
        $headers .= "X-Server-Admin: " . $_SERVER['SERVER_ADMIN'] . "\r\n";
        $headers .= "Date: " . date('r', time()) . "\r\n";
        $headers .= "From: $from\r\n";
        $headers .= "To: $to\r\n";
        $headers .= "Subject: $subject\r\n";
        $headers .= "Reply-To: $from\r\n";

        $msg_body .= "Content-Type: multipart/alternative; boundary=\"=_$ctb\"\r\n\r\n";

        $txt_body  = "--=_$ctb";
        $txt_body .= "\r\n";
        $txt_body .= "Content-Transfer-Encoding: 7bit\r\n";
        $txt_body .= "Content-Type: text/plain; charset=" . RCMAIL_CHARSET . "\r\n\r\n";
        $LINE_LENGTH = $rcmail->config->get('line_length', 72);  
        $h2t = new html2text($body, false, true, 0);
        $txt = rc_wordwrap($h2t->get_text(), $LINE_LENGTH, "\r\n");
        $txt = wordwrap($txt, 998, "\r\n", true);
        $txt_body .= "$txt\r\n";
        $txt_body .= "--=_$ctb";
        $txt_body .= "\r\n";
          
        $msg_body .= $txt_body;
          
        $msg_body .= "Content-Transfer-Encoding: quoted-printable\r\n";
        $msg_body .= "Content-Type: text/html; charset=" . RCMAIL_CHARSET . "\r\n\r\n";
        $msg_body .= str_replace("=","=3D",$body);
        $msg_body .= "\r\n\r\n";
        $msg_body .= "--=_$ctb--";
        $msg_body .= "\r\n\r\n";
                
        // send message
        if($rcmail->config->get('default_smtp_server')=="") { //PHP Mail Function
          $rc = mail($to, $subject, $msg_body, $headers);
        }
        else { 
          if (!is_object($rcmail->smtp))
            $rcmail->smtp_init(true);
        
          if($rcmail->config->get('smtp_pass') == "%p"){
            $rcmail->config->set('smtp_server', $rcmail->config->get('default_smtp_server'));
            $rcmail->config->set('smtp_user', $rcmail->config->get('default_smtp_user'));
            $rcmail->config->set('smtp_pass', $rcmail->config->get('default_smtp_pass'));
          }          
          $rcmail->smtp->connect();
          $rc = $rcmail->smtp->send_mail($from, $to, $headers, $msg_body);  
        }
        if($rc){
          $message = $this->gettext('messagesent');
          $type = "confirmation";
        }
        else{
          $message = $this->gettext('sendingfailed');
          $type = "error";
        }
      }
      else{
        $message = $this->gettext('sendingfailed');
        $type = "error";
      }
          
      $rcmail->output->command('display_message', $message, $type);
      $rcmail->output->send('login');

    }
    
    return $args;
  
  }
  
  function getVisitorIP()
  { 
  
    //Regular expression pattern for a valid IP address 
    $ip_regexp = "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/"; 

    //Retrieve IP address from which the user is viewing the current page 
    if (isset ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"]) && !empty ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"])) { 
      $visitorIP = (!empty ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"])) ? $HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"] : ((!empty ($HTTP_ENV_VARS['HTTP_X_FORWARDED_FOR'])) ? $HTTP_ENV_VARS['HTTP_X_FORWARDED_FOR'] : @ getenv ('HTTP_X_FORWARDED_FOR')); 
    } 
    else { 
      $visitorIP = (!empty ($HTTP_SERVER_VARS['REMOTE_ADDR'])) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ((!empty ($HTTP_ENV_VARS['REMOTE_ADDR'])) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : @ getenv ('REMOTE_ADDR')); 
    } 

    return $visitorIP; 
  }  

}
?>