<?php

/**
 * domain_check
 *
 * @version 1.1 - 31.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 */
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/
 
class domain_check extends rcube_plugin
{
  public $noajax = true;
  public $noframe = true;
  
  /* unified plugin properties */
  static private $plugin = 'domain_check';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = '<a href="http://myroundcube.com/myroundcube-plugins/domain_check-plugin" target="_new">Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '1.1';
  static private $date = '31-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.7.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = array(
  );
  static private $config_dist = null;

  function init(){
    $rcmail = rcmail::get_instance();
    if(!in_array('global_config', $rcmail->config->get('plugins', array()))){
      $this->load_config();
    }
    $this->add_hook('login_after', array($this, 'login_after'));
  }
  
  static public function about($keys = false){
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function login_after($args){
    $temp = explode('@', $_SESSION['username']);
    if(count($temp) == 2){
      $rcmail = rcmail::get_instance();
      $allowed = $rcmail->config->get('allowed_domains', array());
      if(count($allowed) > 0 && !in_array(strtolower($temp[1]), $allowed)){
        foreach($_SESSION as $key => $val){
          unset($_SESSION[$key]);
        }
        if($rcmail->config->get('domain_check_failed', 'error') == 'error'){
          raise_error(array('code' => 401, 'type' => 'php', 'message' => 'Access denied'), false, true);
        }
        else if($rcmail->config->get('domain_check_failed', 'logout') == 'redirect'){
          header('Location: ' . $rcmail->config->get('domain_check_failed', './?_task=logout'));
        }
        else{
          header('Location: ./?_task=logout');
        }
        exit;
      }
    }
    return $args;
  }
}
?>