<?php

/**
 * embed_images
 *
 * @version 1.0 - 20.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 */
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/
 
class embed_images extends rcube_plugin
{
  public $task = 'mail';
  public $noajax = true;
  public $noframe = true;
  
  /* unified plugin properties */
  static private $plugin = 'embed_images';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = null;
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '1.0';
  static private $date = '20-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = array(
  );
  static private $config_dist = null;

  function init(){
    $this->add_hook('message_outgoing_body', array($this, 'message_outgoing_body'));
  }
  
  static public function about($keys = false){
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function message_outgoing_body($args){
    $args['body'] = preg_replace('/\x00/', '', $args['body']);
    $reg = '/<img\s+src\s*=\s*([\"\'][^\"\']+[\"\']|[^>]+)>/i';
    $count = preg_match_all($reg, $args['body'], $imgs);
    if($count > 0 && is_array($imgs[0])){
      if(!class_exists('Http')){
        require_once('class.http.php');
      }
      $http = new Http();
      if(ini_get('safe_mode') || ini_get('open_basedir')){
        $http->useCurl(false);
      }
      $http->SetTimeout(5);
      foreach($imgs[0] as $key => $img){
        preg_match_all('/src=[\'"]([^\'"]+)/i', $img, $urls);
        if(isset($urls[1][0])){
          $url = $urls[1][0];
          $temp = explode('/', $url);
          $temp = $temp[count($temp) - 1];
          $temp = explode('.', $temp);
          if(count($temp) > 1){
            $ext = $temp[count($temp) - 1];
            $type = 'image/' . $ext;
          }
          else{
            $type = null;
            $ext = '';
          }
          $check = parse_url($url);
          if(isset($check['scheme']) && isset($check['host']) && isset($check['path'])){
            $http->execute($url);
            if($http->error){
              continue;
            }
            else{
              $content = $http->result;
              $file = slashify(rcmail::get_instance()->config->get('temp_dir', 'temp/')) . md5($url) . '.' . $ext;
              if(@file_put_contents($file, $content)){
                $args['body'] = str_replace($url, $file, $args['body']);
                $args['message']->addHTMLImage($file, $type, '', true, md5($url) . '.' . $ext);
                @unlink($file);
              }
            }
          }
        }
      }
    }
    return $args;
  }
}
?>