<?php
/**
 * global_config
 *
 * @version 2.0 - 14.09.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 * 
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/
 
class global_config extends rcube_plugin
{
  /* unified plugin properties */
  static private $plugin = 'global_config';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = '<a href="http://myroundcube.com/myroundcube-plugins/plugins-installation#registering_plugin_manager_and_global_config" target="_new">Installation Guide</a><br /><a href="http://myroundcube.com/myroundcube-plugins/global-configuration#global_config" target="_new">Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '2.0';
  static private $date = '14-09-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1',
    'required_plugins' => array(
      'qtip' => 'require_plugin',
      'jqueryui' => 'require_plugin',
      'qtip' => 'require_plugin',
    ),
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  function init()
  {
    $rcmail = rcmail::get_instance();
    $this->load_config();

    if($rcmail->task == 'settings'){
      $skin = $rcmail->config->get('skin', 'classic');
      $excluded_skins = $rcmail->config->get('plugin_manager_excluded_skins', array());
      if(!in_array($skin, $excluded_skins)){
        $this->require_plugin('settings');
      }
      else{
        $this->add_hook('preferences_save', array($this, 'saveprefs'));
      }
    }
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
             $requirements[$prefix.'plugins'][$plugin] = array(
               'method' => $method,
               'plugin' => $plugin,
             );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }

  function saveprefs($prefs)
  {
    global $CONFIG;
    $rcmail = rcmail::get_instance();
    $prefs['prefs']['skin'] = $rcmail->config->get('default_skin', 'larry');
    $protected = $rcmail->config->get('dont_override', array());
    foreach($protected as $key => $config){
      if($config == 'skin'){
        unset($protected[$key]);
        break;
      }
    }
    $CONFIG['dont_override'] = $protected;
    return $prefs;
  }
}
?>