<?php
/**
 * google_ads
 *
 * @version 3.3 - 10.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 * 
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/    
 
class google_ads extends rcube_plugin
{
  public $noframe = true;
  public $noajax = true;
  private $rcmail;
  
  /* unified plugin properties */
  static private $plugin = 'google_ads';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = 'Please re-configure the plugin. Skins have been renamed. "default" has to become "classic" since Roundcube 0.8.x.<br /><a href="http://myroundcube.com/myroundcube-plugins/google_ads-plugin" target="_new">Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '3.3';
  static private $date = '10-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  function init()
  {
    $this->rcmail = rcmail::get_instance();
    if($this->rcmail->action == 'plugin.plugin_manager_update')
      return;
    if(!in_array('global_config', $this->rcmail->config->get('plugins'))){
      $this->load_config();
    }
    if(is_array($this->rcmail->config->get('google_ads_templates')) && !get_input_value('_popup', RCUBE_INPUT_GET) && !get_input_value('_orig_source', RCUBE_INPUT_GET)){
      $skin = $this->rcmail->config->get('skin','classic');
      if(file_exists('plugins/google_ads/skins/' . $skin . '/google_ads.js')){
        $this->include_script('skins/' . $skin . '/google_ads.js');
        $this->add_hook('render_page', array($this, 'render_page'));
      }
      else{
        return;
      }
    }
  }
  
  static public function about($keys = false){
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
             $requirements[$prefix.'plugins'][$plugin] = array(
               'method' => $method,
               'plugin' => $plugin,
             );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }

  function render_page($args){
    if($this->rcmail->action == 'print' || $args['template'] == 'sticky_notes.add_note')
      return $args;
    $blankpages = $this->rcmail->config->get('blankpage','blank.php');
    if(is_array($blankpages)){
      $blankpage = $blankpages[$this->rcmail->config->get('skin','classic')];
    }
    $skin = $this->rcmail->config->get('skin','classic');
    if($args['template'] != 'settings'){
      $args['content'] = str_replace('skins/' . $skin . '/watermark.html','plugins/google_ads/skins/' . $this->rcmail->config->get('skin','classic') . '/' . $blankpage,$args['content']);
      if($args['template'] == 'login'){
        $this->add_texts('localization/', true);
        if($this->rcmail->config->get('allow_adblock', false)){
          $script="function block_check(){
  if(!document.getElementById('aswift_1_anchor') && !document.getElementById('google_ads_frame1')){
    rcmail.display_message(rcmail.gettext('google_ads.ads_error'),'error');
    $('.demo').hide();
    $('.Register').hide();
    $('.button').prop('disabled', true);
    window.setTimeout('block_check()', 2000);
  }
  else{
    $('.demo').show();
    $('.Register').show();
    $('.button').prop('disabled', false);
    window.setTimeout('block_check()', 2000);
  }
}";
          $this->rcmail->output->add_script($script, 'head');
          $this->rcmail->output->add_script("window.setTimeout('block_check()', 500);", 'docready');
        }
      }
    }
    else{
      $script = 'try{document.getElementById("prefs-frame").src="plugins/google_ads/skins/' . $this->rcmail->config->get('skin','classic') . '/' . $blankpage . '"} catch(e){document.getElementById("preferences-frame").src="plugins/google_ads/skins/' . $this->rcmail->config->get('skin','classic') . '/' . $blankpage . '"}';
      $this->rcmail->output->add_script($script,'foot');
    }
    $this->rcmail->output->set_env('blankpage','plugins/google_ads/skins/' . $this->rcmail->config->get('skin','classic') . '/' . $blankpage);
    $credentials = $this->rcmail->config->get('google_ads_templates', array());
    if(is_array($credentials[$this->rcmail->config->get('skin','classic')])){
      $credentials = $credentials[$this->rcmail->config->get('skin','classic')];
    }
    $this->rcmail->output->set_env('google_ads', true);
    if($_SERVER['HTTPS'])
      $https = 's';
    else
      $https = '';
    $left = 0;
    if($_SESSION['user_id'] && $this->rcmail->config->get('google_ads_deferred')){
      $this->include_script('ads.js');
      $async = true;
      $this->rcmail->output->add_header(html::tag('style', array('type' => 'text/css'), '.loading{ background: url(plugins/google_ads/skins/' . $skin . '/images/ajaxloader.gif) no-repeat center 20px; }'));
    }
    foreach($credentials as $key => $credential){
      $left = ($left + 10) + $key * (int) $credential['google_ad_width'];
      $id = 'google_ads_' . $this->rcmail->task . '_' . str_replace('.','_',$this->rcmail->action) . '_' . $key;
      if($async){
        $arguments = array($id, $https, $key, $credential['google_ad_client'], $credential['google_ad_slot'], $credential['google_ad_width'], $credential['google_ad_height']);
        $concat = '';
        foreach($arguments as $argument){
          $concat .= '"'. $argument . '",';
        }
        $concat = substr($concat, 0, strlen($concat) - 1);
        if($key == 0)
          $this->rcmail->output->add_script('$(window).load(function(){window.setTimeout(' . "'" . 'inject_ads(' . $concat . ')' . "'" . ', ' . ($key + 1) . ')});', 'foot');
        else
          $this->rcmail->output->add_script('var google_ads_https="' . $https . '"; var google_ads_id="' . $id . '"; var google_ads_client = "' . $credential['google_ad_client'] . '";var google_ads_slot = "' . $credential['google_ad_slot'] . '";var google_ads_width = ' . $credential['google_ad_width'] . ';var google_ads_height = ' . $credential['google_ad_height'] . ';');
        $script = '';
      }
      else{
        $this->rcmail->output->add_footer(html::tag('script', array('type' => 'text/javascript'), 'google_ad_client = "' . $credential['google_ad_client'] . '";google_ad_slot = "' . $credential['google_ad_slot'] . '";google_ad_width = ' . $credential['google_ad_width'] . ';google_ad_height = ' . $credential['google_ad_height'] . ';'));
        $script = html::tag('script', array('type' => 'text/javascript', 'src' => 'http' . $https . '://pagead2.googlesyndication.com/pagead/show_ads.js'));
      }
      $div = html::tag('div', array('class' => 'loading', 'style'=> 'display:none;position:absolute;bottom:0;top:85px;left:' . $left . 'px;z-index:' . (9999 + $key), 'id' => $id), $script);
      $this->rcmail->output->add_footer($div);
    }
    return $args;
  }
}
?>