<?php

/**
 * Change hMailServer Spam Filter
 *
 *
 * @version 2.7 - 29.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 *
 **/
 
/**
 * Usage: http://mail4us.net/myroundcube/
 *
 * REQUIREMENTS: (*) hMailServer 5.x
 *               (*) settings plugin @website http://myroundcube.googlecode.com
 *                   (since Roundcube 0.6 the plugin is loaded automatically)
 * 
 **/ 

class hmail_spamfilter extends rcube_plugin
{
  public $task = 'mail|settings';
  
  private $sql_select_account       = 'SELECT accountid FROM hm_accounts WHERE accountaddress=%u';  
  private $sql_select_rule          = 'SELECT ruleid, ruleaccountid, rulename, ruleactive, ruleuseand, rulesortorder FROM hm_rules WHERE ruleaccountid=%u AND rulename =%r';
  private $sql_select_rule_criteria = 'SELECT criteriamatchvalue FROM hm_rule_criterias WHERE criteriaruleid=%id';
  private $sql_update_rule          = 'UPDATE hm_rules SET ruleactive=%b WHERE ruleid=%id';
  private $sql_update_criteria      = 'UPDATE hm_rule_criterias SET criteriamatchvalue=%v WHERE criteriaruleid=%id';
  private $sql_update_action        = 'UPDATE hm_rule_actions SET actionimapfolder=%f WHERE actionruleid=%id';
  private $sql_insert_rule          = "INSERT INTO hm_rules (ruleaccountid,rulename,ruleactive,ruleuseand,rulesortorder)  VALUES(%id,%r,%b,'1','1')";
  private $sql_insert_rule_criteria = "INSERT INTO hm_rule_criterias (criteriaruleid,criteriausepredefined,criteriapredefinedfield,criteriaheadername,criteriamatchtype,criteriamatchvalue)  VALUES(%id,'0','1',%n,'4',%s)";  
  //private $sql_insert_rule_action   = "INSERT INTO hm_rule_actions (actionruleid,actiontype,actionimapfolder,actionsortorder,actionrouteid)  VALUES(%id,'4',%f,'0','0')";  
  //http://www.roundcubeforum.net/7-third-party-contributions/46-api-based-plugins/6958-spam-filter-plugin-hmailserver-5-a.html
  private $sql_insert_rule_action   = "INSERT INTO hm_rule_actions (actionruleid,actiontype,actionimapfolder,actionsubject,actionfromname,actionfromaddress,actionto,actionbody,actionfilename,actionsortorder,actionscriptfunction,actionheader,actionvalue,actionrouteid) VALUES(%id,'4',%f,'','','','','','','0','','','',' 0')";
  
  /* unified plugin properties */
  static private $plugin = 'hmail_spamfilter';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = 'Requires hMailserver';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '2.7';
  static private $date = '29-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.7.1',
    'PHP' => '5.2.1',
    'required_plugins' => array('settings' => 'require_plugin')
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  function init()
  {
    $rcmail = rcmail::get_instance();

    if($rcmail->user->data['username'] == $_SESSION['username']){
      $this->_load_config();
      $this->add_texts('localization/');
      $this->add_hook('user_create', array($this, 'user_create'));
      if($rcmail->task == 'mail'){
        $this->add_hook('template_object_summary_spamfilter', array($this, 'hmail_spamfilter_form_obj'));
      }
      else{          
        $this->register_action('plugin.hmail_spamfilter', array($this, 'hmail_spamfilter_init'));
        $this->register_action('plugin.hmail_spamfilter-save', array($this, 'hmail_spamfilter_save'));
        $this->register_action('plugin.hmail_spamfilter-uninstall', array($this, 'hmail_spamfilter_uninstall'));
        $this->register_handler('plugin.hmail_spamfilter_form', array($this, 'hmail_spamfilter_form'));
        $this->register_action('plugin.hmail_spamfilter_show', array($this, 'frame'));
        $this->include_script('hmail_spamfilter.js');
        $this->add_hook('preferences_save', array($this, 'save_prefs'));
      }
    }       
  }
  
  function hmail_spamfilter_uninstall()
  {
    $rcmail = rcmail::get_instance();
    $settings = $this->_get();
    $this->_save(
      strtolower($rcmail->user->data['username']),
      0,
      $settings['id'],
      $settings['sensitivity'],
      $settings['accountid'],
      $junk_mbox
    );
    $rcmail->output->command('plugin.plugin_manager_success', '');
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
             $requirements[$prefix.'plugins'][$plugin] = array(
               'method' => $method,
               'plugin' => $plugin,
             );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function _load_config()
  {
    $rcmail = rcmail::get_instance();
    if(!in_array('global_config', $rcmail->config->get('plugins'))){
      $this->load_config();
      $this->require_plugin('settings');
    }
  }

  function frame()
  {
    $rcmail = rcmail::get_instance();
    $rcmail->output->add_script("rcmail.add_onload(\"rcmail.sections_list.select('accountlink')\");");
    $rcmail->output->add_script("rcmail.add_onload(\"document.frames['prefs-frame'].location.href='./?_task=settings&_action=plugin.hmail_spamfilter&_framed=1'\");");       
    $rcmail->output->send("settings");
    exit;
  }

  function user_create($a)
  { 
    $rcmail = rcmail::get_instance();
    $_POST['_junk_mbox'] = $rcmail->config->get('junk_mbox');
    $rcmail->user->data['username'] = $a['user'];
    $this->save_prefs(array('section'=>'folders', 'initial'=>1));
    return $a;
  }
  
  function save_prefs($a)
  {
    if($a['section'] == 'folders'){
      $junk_mbox = get_input_value('_junk_mbox', RCUBE_INPUT_POST);
      $settings = $this->_get();
      if($a['initial'] == 1)
        $settings['spamfilterenabled'] = 1;
      $rcmail = rcmail::get_instance();
      $this->_save(
        strtolower($rcmail->user->data['username']),
        $settings['spamfilterenabled'],
        $settings['id'],
        $settings['sensitivity'],
        $settings['accountid'],
        $junk_mbox
        );
    }
    return $a;
  }
   
  function hmail_spamfilter_init()
  {

    $rcmail = rcmail::get_instance();
    $rcmail->output->set_pagetitle($this->gettext('spamfilter')); 
    $rcmail->output->send('hmail_spamfilter.hmail_spamfilter');
    
  }
  
  function hmail_spamfilter_save()
  {
     
    $rcmail = rcmail::get_instance();
    $user        = strtolower($rcmail->user->data['username']);
    $accountid   = get_input_value('_accountid', RCUBE_INPUT_POST);
    $enabled     = (NULL != get_input_value('_spamfilterenabled', RCUBE_INPUT_POST));
    $ruleid      = get_input_value('_spamfilterid', RCUBE_INPUT_POST);
    $sensitivity = get_input_value('_spamfiltersensitivity', RCUBE_INPUT_POST);

    if (($res = $this->_save($user,$enabled,$ruleid,$sensitivity,$accountid))) {
      if($res === true)
        $rcmail->output->command('display_message', $this->gettext('successfullysaved'), 'confirmation');
      else if ($res === -1)
        $rcmail->output->command('display_message', $this->gettext('errorsaving'), 'error');
      else 
        $rcmail->output->command('display_message', $res, 'error');
    }

    $this->hmail_spamfilter_init();
  
  }
  
  function hmail_spamfilter_form_obj($args)
  {
    $rcmail = rcmail::get_instance();  
    $settings = $this->_get();
    
    $enabled = $settings['spamfilterenabled'];
    $sensitivity = $settings['sensitivity'];
    
    if($enabled == 1){
      $class = "ok";
      $label_stat = $this->gettext('spamfilterisenabled');
      $label_sens = $this->gettext('spamfiltersensitivity');
      $a_keys = array();
      $count = 12;
      while($count > 0){
        $count = $count - 2;
        $a_keys[] = $count;
      }
      $a_values = array();
      $score_map = $rcmail->config->get('spamfilter_score_map');
      $a_values[$score_map[0]] = $this->gettext('spamfiltersensitivity_very_low');
      $a_values[$score_map[1]] = $this->gettext('spamfiltersensitivity_low');
      $a_values[$score_map[2]] = $this->gettext('spamfiltersensitivity_normal');
      $a_values[$score_map[3]] = $this->gettext('spamfiltersensitivity_high');
      $a_values[$score_map[4]] = $this->gettext('spamfiltersensitivity_very_high');
    
      $label_sens .= ": " . $a_values[$sensitivity];
      
      $label_sens = '&nbsp;(' . $label_sens . ')' . '&nbsp;...';      
    }
    else{
      $class = "warning";
      $label_stat = $this->gettext('spamfilterdisabled');      
    }            
    
    $out  = '<fieldset><legend>&nbsp;' . $this->gettext('spamfilter') . '&nbsp;</legend>';
    $out .= '<br /><div>';
    $out .= '&nbsp;' . $label_stat . '&nbsp;...';
    $out .= $label_sens;    
    $out .= '&nbsp;[<a class= "summary' . $class . ' summaryaction" href="./?_task=settings&_action=plugin.hmail_spamfilter_show">' . $this->gettext('edit') . '</a>]';
    $out .= '</div><br />';
    $out .= '</fieldset>';
    
    $args['content'] = $out;
    return $args;
  }

  function hmail_spamfilter_form()
  {
    $rcmail = rcmail::get_instance();
    
    $rcmail->output->add_script("var settings_account=true;");  

    $settings = $this->_get();
    
    if(!is_array($settings))
      $rcmail->output->command('display_message', $this->gettext('databaseerror'), 'error');
    else{    
      $enabled      = $settings['spamfilterenabled'];
      $sensitivity  = $settings['sensitivity'];
    }
        
    $rcmail->output->set_env('product_name', $rcmail->config->get('product_name'));
    $rcmail->output->set_env('framed', true);

    // return the complete edit form as table
    $user = $rcmail->user->data['username'];
    if($_SESSION['global_alias'])
      $user = $_SESSION['global_alias'];
    $out .= '<fieldset><legend>' . $this->gettext('spamfilter') . ' ::: ' . $user . '</legend>' . "\n";
    $out .= '<br />' . "\n";
    $out .= "<table>\n";

    // show spamfilter properties  
    $field_id = 'spamfilterenabled';
    $input_spamfilterenabled = new html_checkbox(array('name' => '_spamfilterenabled', 'id' => $field_id, 'value' => 1));

    $out .= sprintf("<tr><td class=\"title\"><label for=\"%s\">%s</label>:</td><td>%s</td></tr>\n",
                $field_id,
                rep_specialchars_output($this->gettext('spamfilterenabled')),
                $input_spamfilterenabled->show($enabled?1:0));
    
    $a_keys = array();
    $count = 12;
    while($count > 0){
      $count = $count - 2;
      $a_keys[] = $count;
    }
    $a_values = array();
    $score_map = $rcmail->config->get('spamfilter_score_map');
    $a_values[$score_map[0]] = $this->gettext('spamfiltersensitivity_very_low');
    $a_values[$score_map[1]] = $this->gettext('spamfiltersensitivity_low');
    $a_values[$score_map[2]] = $this->gettext('spamfiltersensitivity_normal');
    $a_values[$score_map[3]] = $this->gettext('spamfiltersensitivity_high');
    $a_values[$score_map[4]] = $this->gettext('spamfiltersensitivity_very_high');
                
    $field_id = 'spamfiltersensitivity';
    $input_spamfiltersensitivity = new html_select(array('name' => '_spamfiltersensitivity', 'id' => $field_id));
    $input_spamfiltersensitivity->add(array_values($a_values), $a_keys);
    $out .= sprintf("<tr><td class=\"title\"><label for=\"%s\">%s</label>:</td><td>%s</td></tr>\n",
                $field_id,
                rep_specialchars_output($this->gettext('spamfiltersensitivity')),
                $input_spamfiltersensitivity->show($a_values[$sensitivity]));

    $out .= "\n</table>";
    $out .= '<br />' . "\n";
    $out .= "</fieldset>\n";    

    $field_id = 'spamfilterid';
    $input_spamfilterid = new html_hiddenfield(array('name' => '_spamfilterid', 'id' => $field_id, 'value' => $settings['id']));
    $out .= $input_spamfilterid->show();
    
    $field_id = 'accountid';
    $input_accountid = new html_hiddenfield(array('name' => '_accountid', 'id' => $field_id, 'value' => $settings['accountid']));
    $out .= $input_accountid->show();    
    
    $rcmail->output->add_gui_object('spamfilterform', 'spamfilter-form');
    
    return $out;
  }
 
  private function _get()
  {
    $rcmail = rcmail::get_instance();
      
    if ($dsn = $rcmail->config->get('db_hmail_spamfilter_dsn')) {
      // #1486067: enable new_link option
      if (is_array($dsn) && empty($dsn['new_link']))
        $dsn['new_link'] = true;
      else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
        $dsn .= '?new_link=true';    
      $db = new rcube_mdb2($dsn, '', FALSE);
      $db->set_debug((bool)$rcmail->config->get('sql_debug'));
      $db->db_connect('r');
    } else {
      die("FATAL ERROR ::: RoundCube Plugin ::: hmail_spamfilter ::: \$rcmail_config['db_hmail_spamfilter_dsn'] undefined !!! ==> die");
    }
    if ($err = $db->is_error())
      return $err;
      
    $sql = $this->sql_select_account;      
    $sql = str_replace('%u', $db->quote($rcmail->user->data['username'],'text'), $sql);
    $res = $db->query($sql);
                 
    if ($err = $db->is_error()){
       return $err;
    }
    $ret = $db->fetch_assoc($res);
    
    $sql = $this->sql_select_rule;
    $accountid = $ret['accountid'];
    $sql = str_replace('%u', $db->quote($accountid,'text'), $sql);
    $sql = str_replace('%r', $db->quote($rcmail->config->get('spamfilter_rule_name'),'text'), $sql);
    
    $res = $db->query($sql);
           
    if ($err = $db->is_error()){
       return $err;
    }
    $ret = $db->fetch_assoc($res);

    $rule = array();
    
    $rule['accountid'] = $accountid;

    if(is_array($ret)){
      $rule['spamfilterenabled'] = $ret['ruleactive'];
      $rule['id'] = $ret['ruleid'];
      $sql = $this->sql_select_rule_criteria;
      $sql = str_replace('%id', $db->quote($ret['ruleid'],'text'), $sql);

      $res = $db->query($sql);
      if ($err = $db->is_error()){
        return $err;
      }
      $ret = $db->fetch_assoc($res);
      $rule['sensitivity'] = $ret['criteriamatchvalue'];  
    }
    else{
      $rule['spamfilterenabled'] = 0;
      $rule['sensitivity'] = 6;
      $rule['id'] = -1;
    }

    return $rule;  
  }

  private function _save($user,$enabled,$ruleid,$sensitivity,$accountid,$junk_mbox=false)
  {
    if(!$enabled)
        $enabled = 0;

    $rcmail = rcmail::get_instance();
    
    if(!$junk_mbox)
      $junk_mbox = $rcmail->config->get('junk_mbox', 'Junk');
           
    if ($dsn = $rcmail->config->get('db_hmail_spamfilter_dsn')) {
      // #1486067: enable new_link option
      if (is_array($dsn) && empty($dsn['new_link']))
        $dsn['new_link'] = true;
      else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
        $dsn .= '?new_link=true';    
      $db = new rcube_mdb2($dsn, '', FALSE);
      $db->set_debug((bool)$rcmail->config->get('sql_debug'));
      $db->db_connect('r');
    } else {
      die("FATAL ERROR ::: RoundCube Plugin ::: hmail_spamfilter ::: \$rcmail_config['db_hmail_spamfilter_dsn'] undefined !!! ==> die");
    }
    if ($err = $db->is_error())
      return $err;

    if($ruleid == -1){
      $sql = $this->sql_insert_rule;
      $sql = str_replace('%id', $db->quote($accountid,'text'), $sql);
      $sql = str_replace('%r', $db->quote($rcmail->config->get('spamfilter_rule_name'),'text'), $sql);
      $sql = str_replace('%b', $db->quote($enabled,'text'), $sql);
      
      $res = $db->query($sql);
      
      if ($err = $db->is_error()){
        return $err;
      }
      
      $settings = $this->_get();  
      if(is_array($settings)){
        $ruleid = $settings['id'];
      }
      else{
        return -1;
      }
 
      $sql = $this->sql_insert_rule_criteria;
      $sql = str_replace('%id', $db->quote($ruleid,'text'), $sql);
      $sql = str_replace('%n', $db->quote($rcmail->config->get('spamfilter_header_field'),'text'), $sql);
      $sql = str_replace('%s', $db->quote($sensitivity,'text'), $sql);
      
      $res = $db->query($sql);
                 
      if ($err = $db->is_error()){
        return $err;
      }

      $sql = $this->sql_insert_rule_action;
      $sql = str_replace('%id', $db->quote($ruleid,'text'), $sql);
      $sql = str_replace('%f', $db->quote($junk_mbox,'text'), $sql);
      
      $res = $db->query($sql);
      
      $this->reload($user);
      
      if ($err = $db->is_error()){
        return $err;
      }
    }
    else{
      $sql = $this->sql_update_rule;       
      $sql = str_replace('%b', $db->quote($enabled,'text'), $sql);
      $sql = str_replace('%id', $db->quote($ruleid,'text'), $sql);
      
      $res = $db->query($sql);
                 
      if ($err = $db->is_error()){
        return $err;
      }
      
      $sql = $this->sql_update_criteria;
      $sql = str_replace('%v', $db->quote($sensitivity,'text'), $sql);
      $sql = str_replace('%id', $db->quote($ruleid,'text'), $sql);
      $res = $db->query($sql);
                 
      if ($err = $db->is_error()){
        return $err;
      }
       
      $sql = $this->sql_update_action;
      $sql = str_replace('%f', $db->quote($junk_mbox,'text'), $sql);
      $sql = str_replace('%id', $db->quote($ruleid,'text'), $sql);
      $res = $db->query($sql);
      
      $this->reload($user);

      if ($err = $db->is_error()){
        return $err;
      } 
    }

    return true;
  }
  
  private function reload($user)
  {
    $rcmail = rcmail::get_instance();
    if($rcmail->config->get('hmail_client')){
      $temparr = explode("@",$user);
      $domain = $temparr[1];
      if(!class_exists('Http')){
        include INSTALL_PATH . 'plugins/hmail_spamfilter/class.http.php';
      }
      $httpConfig['method']     = 'POST';
      $httpConfig['target']     = $rcmail->config->get('hmail_client') . '?_action=reload';
      $httpConfig['timeout']    = '30';
      $httpConfig['params']     = array('_domain' => $domain, '_username' => $user, '_oldpw' => $rcmail->decrypt($_SESSION['password']));
      $http = new Http();
      $http->initialize($httpConfig);
      if(ini_get('safe_mode') || ini_get('open_basedir')){
        $http->useCurl(false);
      }
      $http->execute();
      if($http->error){
        write_log('errors', 'Plugin hmail_spamfilter: Connection failed [' . $rcmail->config->get('hmail_client') . '?_action=reload]');
        return false;
      }
      else{
        $response = $http->result;
        if($response == 'ok'){
          return true;
        }
        else{
          write_log('errors', 'Plugin hmail_spamfilter: Reload request failed [' . $user . ']');
          return false;
        }
      }
    }
  }
  
}

?>