<?php
/**
 * idle_timeout
 *
 * @version 2.6 - 11.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 * 
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/    
 
class idle_timeout extends rcube_plugin{
  
  private $rcmail;

  /* unified plugin properties */
  static private $plugin = 'idle_timeout';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = '<a href="http://myroundcube.com/myroundcube-plugins/idle_timeout-plugin" target="_new">Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '2.6';
  static private $date = '11-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  function init(){
    $this->add_texts('localization/', true);
    $this->add_hook('render_page', array($this, 'render_page'));
    $this->register_action('plugin.idle_timeout_logout', array($this, 'idle_logout'));
    $this->rcmail = rcmail::get_instance();
    if(!in_array('global_config', $plugins = $this->rcmail->config->get('plugins'))){
      $this->load_config();
    }
  }
  
  static public function about($keys = false){
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function render_page($p){
    if($_SESSION['username']){
      $cn = $this->rcmail->config->get('ifpl_cookie_name', '_pt');
      if(!get_input_value($cn, RCUBE_INPUT_GPC) && !$_SESSION['noidletimeout']){
        $this->rcmail->output->set_env('idle_timeout_warning', $this->rcmail->config->get('idle_timeout_warning',5));
        $this->rcmail->output->set_env('idle_timeout_logout', $this->rcmail->config->get('idle_timeout_logout',5));
        $this->include_script('idle.js');
      }
    }
    else if($p['template'] == 'login'){
      if($t = get_input_value('_idle_timeout', RCUBE_INPUT_GPC)){
        $skin = 'classic';
        if(file_exists('plugins/idle_timeout/skins/' . $this->rcmail->config->get('skin','classic') . '/idle_timeout.css'))
          $skin = $this->rcmail->config->get('skin','classic');
        $this->include_stylesheet("skins/$skin/idle_timeout.css");
        $this->include_script('idle_logout.js');
        $date = date($this->rcmail->config->get('date_long', 'd.m.Y H:i'), $t);
        $footer = '<div id="idle_timeout_box" class="idle_timeout_box"><p>' . str_replace('%s', $date, $this->gettext('idletimeoutlogoutinfo')) . '</p></div>';
        $this->rcmail->output->add_footer($footer);
      }
    }
    return $p;
  }
  
  function idle_logout(){
    if(!empty($this->rcmail->user->ID) && !$_SESSION['noidletimeout']){
      $this->rcmail->output->redirect(array('_task' => 'logout', '_idle_timeout' => time()));
    }
  }
  
  function q($str){
    return $this->rcmail->db->quoteIdentifier($str);
  }
  
  function table($str){
    return $this->rcmail->db->quoteIdentifier(get_table_name($str));
  }
}
?>