<?php
chdir(dirname(__FILE__));
$time_start = microtime_float();
$time_start_s = time();

if(isset($_SERVER['REMOTE_ADDR']))
  die("Access denied");

/* Configuration */
if(isset($_SERVER['SCRIPT_FILENAME']))
  $dir = dirname($_SERVER['SCRIPT_FILENAME']);
else if(isset($_SERVER['SCRIPT_NAME']))
  $dir = dirname($_SERVER['SCRIPT_NAME']);
else{
  die("Can't detect File Location");
}
$dir = str_replace('plugins/scheduled_sending/cron','',$dir);
$dir = str_replace('plugins\\scheduled_sending\\cron','',$dir);
if(file_exists($dir . 'plugins/scheduled_sending/cron/sendmail.php')){
  define('INSTALL_PATH', str_replace('plugins/scheduled_sending/cron','',$dir));
}
else{
  $dir = str_replace('plugins/scheduled_sending/cron','',$_SERVER['PWD']);
  define('INSTALL_PATH', $dir);
}
if(file_exists(INSTALL_PATH . 'plugins/global_config/config.inc.php')){
  include INSTALL_PATH . 'plugins/global_config/config.inc.php';
}
else{
  $ext = ".dist";
  if(file_exists(INSTALL_PATH . 'plugins/scheduled_sending/config.inc.php'))
    $ext = "";
  include INSTALL_PATH . 'plugins/scheduled_sending/config.inc.php' . $ext;
}
define('RCMAIL_URL', $rcmail_config['cron_rc_url']);
/* End Configuration */

/* Functions */
function microtime_float(){
  list($usec, $sec) = explode(" ", microtime());
  return ((float)$usec + (float)$sec);
}

function dbq($str, $rcmail) {
  return $rcmail->db->quoteIdentifier($str);
}
  
function dbtable($str, $rcmail) {
  return $rcmail->db->quoteIdentifier(get_table_name($str));
}

function send($from,$to,$subject,$headers,$body,$rcmail){
  $headers = trim($headers) . "\r\n\r\n";
  if(!$rcmail->config->get('cron_smtp_user')) {
    $ret = mail($to, $subject, $body, $headers);
  }
  else {
    if(!is_object($rcmail->smtp))
      $rcmail->smtp_init(true);
    $ret = $rcmail->smtp->send_mail($from, $to, $headers, $body);
  }
  return $ret;
}

/* End Functions */

/* Program */
include INSTALL_PATH . 'program/include/iniset.php';
$rcmail = rcmail::get_instance();
foreach($rcmail_config as $key => $val){
  $rcmail->config->set($key, $val);
}
if($rcmail->config->get('smtp_user') != ''){
  $rcmail->config->set('smtp_user',$rcmail->config->get('cron_smtp_user'));
}
if($rcmail->config->get('smtp_pass') != ''){
  $rcmail->config->set('smtp_pass',$rcmail->config->get('cron_smtp_pass'));
}
if(!is_dir($rcmail_config['log_dir']))
  ini_set('error_log', INSTALL_PATH.'logs/errors');

$nupcoming = 0;

$result = $rcmail->db->query(
  "SELECT * FROM " . dbtable(get_table_name('scheduled_sending'),$rcmail) . " 
   WHERE ".dbq('runtime',$rcmail)."<? AND ". dbq('flag',$rcmail)."=?",
   $time_start_s,
   0
);
$success = array();
while ($result && ($message = $rcmail->db->fetch_assoc($result))) {
  $temparr = explode("\n", $message['raw']);
  $message['raw'] = implode("\r\n", $temparr);
  $temparr = explode("\r\n\r\n", $message['raw'], 2);
  $to = '';
  $fields = array('to', 'cc', 'bcc');
  foreach($fields as $field){
    if($message[$field])
      $to .= $message[$field] . ',';
  }
  $to = substr($to, 0, strlen($to) -1);
  preg_match('/from: (.*?)$/im', $temparr[0], $matches);
  $from = trim($matches[1]);
  $repl = preg_match('/\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i', $from, $matches);
  $from = trim($matches[0]);
  $ret = send($from,$to,$message['subject'],$temparr[0],$temparr[1],$rcmail);
  if($ret){
    $nupcoming ++;
    $flag = 1;
  }
  else{
    $flag = 2;
  }
  $success[] = array('id' => $message['id'], 'flag' => $flag);
}
foreach($success as $item){
   $query = $rcmail->db->query(
    "UPDATE " . dbtable(get_table_name('scheduled_sending'),$rcmail) . " SET " . dbq('flag',$rcmail) . "=? WHERE " . dbq('id',$rcmail) . "=?",
    $item['flag'],
    $item['id']
  );
}
$time_end = microtime_float();
$time = $time_end - $time_start;

if($rcmail->config->get('cron_log') == true){
  if($nupcoming > 0){
    write_log('scheduled_sending',"Sendmail cron job");
    write_log('scheduled_sending',"  $nupcoming message(s) sent.");
    write_log('scheduled_sending',"  Script terminated after $time seconds runtime.");
  }
}

$rcmail->session->destroy(session_id());
print "done [$time seconds runtime] " . date('Y-m-d H:i:s',time()) . "\n";
exit;
/* End Program */
?>